/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 2009 Toporov Konstantin. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 3 only ("GPL")  (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.gnu.org/copyleft/gpl.html  See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * You should include file containing license in each project.
 * If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * If you wish your version of this file to be governed by
 * the GPL Version 3, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [GPL Version 3] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under the GPL Version 3 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 3 code and therefore, elected the GPL
 * Version 3 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 *
 * Contributor(s):
 *
 * Portions Copyrighted 2009 Toporov Konstantin.
 */
package maths;

/**
 *
 * @author Toporov Konstantin <www.diacalc.org>
 */

public class SearchString {
    public final static boolean PRODUCTS = true;
    public final static boolean DIARY = false;
    static private String str_conj;
    static private String str_numb;
    static public String getSQLPart(String source,boolean mode,User user){
        str_conj = "";
        str_numb = "";
        String textfield;
        if (mode==PRODUCTS) textfield = "name";
        else textfield = "comment";
        if (source!=null && source.trim().length()>0){
            String [] arr = source.trim().split(" ");
            for(String item:arr){
                String buf = item.trim();
                if (buf.length()>0){
                    if (buf.charAt(0)!='(' || buf.charAt(buf.length()-1)!=')'){
                        //Ищем в текстовом поле
                        if (str_conj.length()!=0) str_conj += " OR ";
                        str_conj += textfield +" LIKE '%"+ buf +"%' OR "+textfield+" LIKE " +
                                "'%"+ getCapFirst(buf) +"%'" ;
                    }else{//Определяем числовое поле
                        if (buf.contains("Б")){
                            int index = buf.indexOf('Б');
                            String f = buf.substring(0+1, index).replace(',', '.');
                            String l = buf.substring(index+1,buf.length()-1).replace(',', '.');
                            if (f.length()>0) str_numb += 
                                    (str_numb.length()>0?" AND ":"") + f + "prot" ;
                            if (l.length()>0) str_numb += 
                                    (str_numb.length()>0?" AND ":"")+"prot" + l;
                        }else 
                        if (buf.contains("Ж")){
                            int index = buf.indexOf('Ж');
                            String f = buf.substring(0+1, index).replace(',', '.');
                            String l = buf.substring(index+1,buf.length()-1).replace(',', '.');
                            if (f.length()>0) str_numb += 
                                    (str_numb.length()>0?" AND ":"") + f + "fats" ;
                            if (l.length()>0) str_numb += 
                                    (str_numb.length()>0?" AND ":"")+"fats" + l;
                        }else 
                        if (buf.contains("У")){
                            int index = buf.indexOf('У');
                            String f = buf.substring(0+1, index).replace(',', '.');
                            String l = buf.substring(index+1,buf.length()-1).replace(',', '.');
                            if (f.length()>0) str_numb += 
                                    (str_numb.length()>0?" AND ":"")+ f + "carb" ;
                            if (l.length()>0) str_numb += 
                                    (str_numb.length()>0?" AND ":"")+"carb" + l;
                        }else 
                        if (buf.contains("ГИ")){
                            int index = buf.indexOf('Г');
                            String f = buf.substring(0+1, index);
                            String l = buf.substring(index+2,buf.length()-1);
                            if (f.length()>0) str_numb += 
                                    (str_numb.length()>0?" AND ":"") + f + "gi" ;
                            if (l.length()>0) str_numb += 
                                    (str_numb.length()>0?" AND ":"")+"gi" + l;
                        }else
                        if (mode==SearchString.DIARY){
                            if (buf.contains("Д")){
                            int index = buf.indexOf('Д');
                            String f = buf.substring(0+1, index).replace(',', '.');
                            String l = buf.substring(index+1,buf.length()-1).replace(',', '.');
                            if (f.length()>0) str_numb += 
                                    (str_numb.length()>0?" AND ":"")+ f + "dose" ;
                            if (l.length()>0) str_numb += 
                                    (str_numb.length()>0?" AND ":"")+"dose" + l;
                            }else
                            if (buf.contains("СК1")){
                                int index = buf.indexOf('С');
                                String f = replaceSugar(
                                        buf.substring(0+1, index).replace(',', '.'),
                                        user);
                                String l = replaceSugar(
                                        buf.substring(index+3,buf.length()-1).replace(',', '.'),
                                        user);
                                if (f.length()>0) str_numb +=
                                    (str_numb.length()>0?" AND ":"") + f + "sh1" ;
                                if (l.length()>0) str_numb +=
                                    (str_numb.length()>0?" AND ":"")+"sh1" + l;

                            }else
                            if (buf.contains("СК2")){
                                int index = buf.indexOf('С');
                                String f = replaceSugar(
                                        buf.substring(0+1, index).replace(',', '.'),
                                        user);
                                String l = replaceSugar(
                                        buf.substring(index+3,buf.length()-1).replace(',', '.'),
                                        user);
                                if (f.length()>0) str_numb +=
                                    (str_numb.length()>0?" AND ":"") + f + "sh2" ;
                                if (l.length()>0) str_numb +=
                                    (str_numb.length()>0?" AND ":"")+"sh2" + l;
                            }else
                            if (buf.contains("СК")){
                                int index = buf.indexOf('С');
                                String f = replaceSugar(
                                        buf.substring(0+1, index).replace(',', '.'),
                                        user);
                                String l = replaceSugar(
                                        buf.substring(index+2,buf.length()-1).replace(',', '.'),
                                        user);
                                String tmp1 = "";
                                String tmp2 = "";

                                if (f.length()>0){
                                    tmp1 = f + "sh1";
                                    tmp2 = f + "sh2";
                                }
                                if (l.length()>0){
                                    tmp1 +=
                                    (tmp1.length()>0?" AND ":"")+"sh1" + l;
                                    tmp2 +=
                                    (tmp2.length()>0?" AND ":"")+"sh2" + l;

                                }
                                if ((tmp1.length()+tmp2.length())>0){
                                    str_numb +=
                                    (str_numb.length()>0?" AND ":"") +
                                       "((" + tmp1 +") OR (" +
                                       tmp2 +"))";
                                }
                                

                            }
                        }
                                
                    }
                }
                
            }
            String res = "";
            if (str_conj.length()>0) res += "("+str_conj +")";
            if (str_conj.length()>0 && str_numb.length()>0) res += " AND ";
            if (str_numb.length()>0) res += ""+str_numb+"";
            return res;
        } else return "";
    }
    static private String getCapFirst(String st){
      if (st!=null && st.length()>0){
        String c = new String("" + st.charAt(0)).toUpperCase();
        if (st.length()>1){
            return c + st.substring(1);
        }
        else return c;
      } return null;
    }
    static private String replaceSugar(String st,User user){
        if (st.length()>0){
            String buf = "";
            for (int i=0;i<st.length();i++){
               if (st.charAt(i)!='<' &&
                 st.charAt(i)!='>' &&
                 st.charAt(i)!='=') buf += st.charAt(i);
            }
            //int pos = st.indexOf(buf);
            //int len = buf.length();

            //String signf = st.substring(0, pos);
            //String signl = st.substring(pos+len, st.length());
            //System.out.println(signf+" "+signl+" "+pos);
            Sugar s = new Sugar();
            s.setSugar(Float.parseFloat(buf), user.isMmol(), user.isPlasma());
            return st.replace(buf, ""+s.getValue() );
            //return signf+s.getValue()+signl;
        }
        return "";
    }
    
}
